#
# access-sample.pl -- Sample IP based access filter
#
# access-sample.pl,v 1.1 1994/11/06 20:48:09 sanders Exp
#
# by Tony Sanders <sanders@earth.com>, Sept 1993
#
# This will restrict access to only your local network.
# Requires configuration.

sub access {
    local($fromfd, $peeraddr, $action, $path, $version) = @_;
    local($mynet) = pack("C4", 128, 46, 0, 0);		# your Class B network
    local($mymask) = 0xffff0000;			# mask for Class B
    &error('forbidden', "$action $path invalid") unless
        (((unpack($main'sockaddr, $peeraddr))[2] & $mymask) == $mynet);
}

1;
